function remote_init()
	local items={
		{name="Keyboard", input="keyboard"},
		{name="Channel Pressure", input="value", min=0, max=127},
		{name="Mod Wheel", input="value", min=0, max=127},
		{name="Pitch Bend", input="value", min=0, max=16384},
		{name="Expression", input="value", min=0, max=127},
		{name="Damper Pedal", input="value", min=0, max=127},

		{name="Fader 1", input="value", min=0, max=127},
		{name="Fader 2", input="value", min=0, max=127},
		{name="Fader 3", input="value", min=0, max=127},
		{name="Fader 4", input="value", min=0, max=127},

		{name="Fader 9", input="value", min=0, max=127},
		{name="Fader 10", input="value", min=0, max=127},
		{name="Fader 11", input="value", min=0, max=127},
		{name="Fader 12", input="value", min=0, max=127},

		{name="Fader 17", input="value", min=0, max=127},
		{name="Fader 18", input="value", min=0, max=127},
		{name="Fader 19", input="value", min=0, max=127},
		{name="Fader 20", input="value", min=0, max=127},

		{name="Fader 25", input="value", min=0, max=127},
		{name="Fader 26", input="value", min=0, max=127},
		{name="Fader 27", input="value", min=0, max=127},
		{name="Fader 28", input="value", min=0, max=127},
				
		{name="Switch 1", input="value", min=0, max=127},
		{name="Switch 2", input="value", min=0, max=127},
		{name="Switch 3", input="value", min=0, max=127},
		{name="Switch 4", input="value", min=0, max=127},

		{name="Switch 9", input="value", min=0, max=127},
		{name="Switch 10", input="value", min=0, max=127},
		{name="Switch 11", input="value", min=0, max=127},
		{name="Switch 12", input="value", min=0, max=127},

		{name="Switch 17", input="value", min=0, max=127},
		{name="Switch 18", input="value", min=0, max=127},
		{name="Switch 19", input="value", min=0, max=127},
		{name="Switch 20", input="value", min=0, max=127},
		
		{name="Switch 25", input="value", min=0, max=127},
		{name="Switch 26", input="value", min=0, max=127},
		{name="Switch 27", input="value", min=0, max=127},
		{name="Switch 28", input="value", min=0, max=127},

		{name="Pad D1", input="button"},
		{name="Pad D2", input="button"},
		{name="Pad D3", input="button"},
		{name="Pad D4", input="button"},
		{name="Pad D5", input="button"},
		{name="Pad D6", input="button"},
		{name="Pad D7", input="button"},
		{name="Pad D8", input="button"},

		{name="Rewind", input="button"},
		{name="Fast Forward", input="button"},
		{name="Stop", input="button"},
		{name="Play", input="button"},
		{name="Record", input="button"},

			}
	remote.define_items(items)

	local inputs={
		{pattern="b0 0C xx", name="Fader 1"},
		{pattern="b0 0D xx", name="Fader 2"},
		{pattern="b0 0E xx", name="Fader 3"},
		{pattern="b0 0F xx", name="Fader 4"},

		{pattern="b1 0C xx", name="Fader 9"},
		{pattern="b1 0D xx", name="Fader 10"},
		{pattern="b1 0E xx", name="Fader 11"},
		{pattern="b1 0F xx", name="Fader 12"},
		
		{pattern="b2 0C xx", name="Fader 17"},
		{pattern="b2 0D xx", name="Fader 18"},
		{pattern="b2 0E xx", name="Fader 19"},
		{pattern="b2 0F xx", name="Fader 20"},

		{pattern="b3 0C xx", name="Fader 25"},
		{pattern="b3 0D xx", name="Fader 26"},
		{pattern="b3 0E xx", name="Fader 27"},
		{pattern="b3 0F xx", name="Fader 28"},

		{pattern="b0 15 xx", name="Switch 1"},
		{pattern="b0 16 xx", name="Switch 2"},
		{pattern="b0 17 xx", name="Switch 3"},
		{pattern="b0 18 xx", name="Switch 4"},

		{pattern="b1 15 xx", name="Switch 9"},
		{pattern="b1 16 xx", name="Switch 10"},
		{pattern="b1 17 xx", name="Switch 11"},
		{pattern="b1 18 xx", name="Switch 12"},
		
		{pattern="b2 15 xx", name="Switch 17"},
		{pattern="b2 16 xx", name="Switch 18"},
		{pattern="b2 17 xx", name="Switch 19"},
		{pattern="b2 18 xx", name="Switch 20"},

		{pattern="b3 20 xx", name="Switch 25"},
		{pattern="b3 21 xx", name="Switch 26"},
		{pattern="b3 22 xx", name="Switch 27"},
		{pattern="b3 23 xx", name="Switch 28"},

		{pattern="9F 00", name="Pad D1", value="1"},
		{pattern="9F 01", name="Pad D2", value="1"},
		{pattern="9F 02", name="Pad D3", value="1"},
		{pattern="9F 03", name="Pad D4", value="1"},
		{pattern="9F 04", name="Pad D5", value="1"},
		{pattern="9F 05", name="Pad D6", value="1"},
		{pattern="9F 06", name="Pad D7", value="1"},
		{pattern="9F 07", name="Pad D8", value="1"},	

		{pattern="e? xx yy", name="Pitch Bend", value="y*128 + x"},
		{pattern="b0 01 xx", name="Mod Wheel"},
		{pattern="b0 0b xx", name="Expression"},
		{pattern="b0 40 xx", name="Damper Pedal"},
		{pattern="d0 xx", name="Channel Pressure"},

		{pattern="80 xx yy", name="Keyboard", value="0", note="x", velocity="64"},
		
		{pattern="90 xx 00", name="Keyboard", value="0", note="x", velocity="64"},
		{pattern="<100x>0 yy zz", name="Keyboard"},

		{pattern="b0 73 7f", name="Rewind", value="1"},
		{pattern="b0 74 7f", name="Fast Forward", value="1"},
		{pattern="b0 75 7f", name="Stop", value="1"},
		{pattern="b0 76 7f", name="Play", value="1"},
		{pattern="b0 77 7f", name="Record", value="1"},
	

	}
	remote.define_auto_inputs(inputs)
end


function remote_probe()

	local controlRequest="F0 7E 7F 06 01 F7"

	local controlResponse="F0 7E 00 06 02 47 16 00 19 00 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? F7"
return {
		request=controlRequest,
		response=controlResponse
	}
end

